%Fresnel diffraction of a circular aperture
%Fig.1.4 in Digital Holography by T.-C. Poon & J.-P. Liu 
close all; clear all;
lambda=0.6*10^-6;   % wavelength, unit:m
delta=10*lambda;    % sampling period, unit:m
z=0.07;             % propagation distance; m
M=512;              % space size
 
c=1:M;
r=1:M;
[C, R]=meshgrid(c, r);
THOR=((R-M/2-1).^2+(C-M/2-1).^2).^0.5;
RR=THOR.*delta;
OB=zeros(M);        % Object 
for a=1:M;
    for b=1:M;
         if RR(a,b)<=5*10^-4;  % aperture radius unit:m
            OB(a,b)=1;
        end
    end
end
 
QP=exp(1i*pi/lambda/z.*(RR.^2)); 
FD=fftshift(fft2(fftshift(OB.*QP)));
FD=abs(FD);
FD=FD/max(max(FD));
 figure; imshow(OB);
title('Circular aperture')
figure; imshow(FD);
title('Modulus of the Fresnel diffraction pattern')
