% High-pass filtering of an image 
% Fig.1.9 in Digital Holography by T.-C. Poon & J.-P. Liu
clear all;close all;
A=imread('lena.jpg');           % read image file
A=double(A);
A=A/255;
SP=fftshift(fft2(fftshift(A)));
D=abs(SP);
D=D(129:384,129:384);
figure;imshow(A);
title('Original image')
figure;imshow(30.*mat2gray(D)); % spectrum
title('Original spectrum')
 
c=1:512;   
r=1:512;
[C, R]=meshgrid(c, r);
CI=((R-257).^2+(C-257).^2);
filter=zeros(512,512);
% produce a high-pass filter
for a=1:512;
    for b=1:512;
 
        if CI(a,b)<=20^2;  %filter diameter
            filter(a,b)=0;
        else
            filter(a,b)=1;
        end
    end
end
G=abs(filter.*SP);
G=G(129:384,129:384);
figure;imshow(2.*mat2gray(G));
title('High-pass spectrum')
SPF=SP.*filter;
E=abs(fftshift(ifft2(fftshift(SPF))));
figure;imshow(mat2gray(E));
title('High-pass image')
