% Incoherent spatial filtering, circ(r/r0)
% Fig.1.10 in Digital Holography by T.-C. Poon & J.-P. Liu
clear all;close all;
A=imread('lena.jpg');           % read image file
A=double(A);
A=A/255;
SP=fftshift(fft2(fftshift(A)));
D=abs(SP);
D=D(129:384,129:384);
figure;imshow(A);
title('Original image')
figure;imshow(30.*mat2gray(D)); % spectrum
title('Original spectrum')
 
c=1:512;   
r=1:512;
[C, R]=meshgrid(c, r);
CI=((R-257).^2+(C-257).^2);
pup=zeros(512,512);
% produce a circular pupil
for a=1:512;
    for b=1:512;
 
        if CI(a,b)>=30^2;  %pupil diameter 30 or 15
            pup(a,b)=0;
        else
            pup(a,b)=1;
        end
    end
end
h=ifft2(fftshift(pup));
 
OTF=fftshift(fft2(h.*conj(h)));
OTF=OTF/max(max(abs(OTF)));
G=abs(OTF.*SP);
G=G(129:384,129:384);
figure;imshow(30.*mat2gray(G));
title('Filtered spectrum')
 
I=abs(fftshift(ifft2(fftshift(OTF.*SP))));
figure;imshow(mat2gray(I));
title('Filtered image')
