% Calculation of chromatic aberration 
% Fig.2.8 in Digital Holography by T.-C. Poon & J.-P. Liu

close all; clear all;
L=20;  % l1 and l2
R=5;
a=5;   % a and b
h=2;
lambda0=633;        % recording wavelength 
lambdaR=400:20:700; % reconstruction wavelength
 
z=lambda0*R*L./(lambdaR*(L-R)-lambda0*R);
dz=R*L/(L-2*R)-z;
plot(lambdaR,dz)
title('Longitudinal chromatic aberration')
xlabel('Reconstruction wavelength (nm)')
ylabel('{\delta}z (mm)')
 
 
x=-z.*(a/L-lambdaR/lambda0*h/R/2-lambdaR*a/lambda0/L);
dx=x-R*L/(L-2*R)*(h/2/R);
figure;plot(lambdaR,dx)
title('Transverse chromatic aberration')
xlabel('Reconstruction wavelength (nm)')
ylabel('{\delta}x (mm)')
