% Complex degree of coherence 
% Fig.2.14 in Digital Holography by T.-C. Poon & J.-P. Liu

close all; clear all;
x=2;  % xa-xb=2 mm
r=200; % r= 200 mm
l=0.6*10^(-3);        % center wavelength 600nm
r0=0.001:0.0005:0.1; % radius of the pinhole aperture
z=2*pi*x.*r0/r/l;
gama=2*besselj(1,z)./z;
gama=abs(gama./max(gama));
 
plot(r0,gama)
title('Complex degree of coherence')
xlabel('Radius (mm)')
ylabel('|\gamma_A_B|')
