% Frequency analysis of a sine function
% Example 4.1 in Digital Holography by T.-C. Poon & J.-P. Liu
 
clear all; close all
 
x=0:0.1:150; % unit in mm sampling period 0.1 mm
y=sin(2*pi.*x/5); % period of 5mm
fmax=1/0.1/2;
fx=linspace(-fmax, fmax, 1501);
SY=abs(fftshift(fft(y)));
  
sx1=0:0.2:300;  % unit in mm sampling period 0.2 mm
sy1=sin(2*pi.*sx1/5); % period of 5mm
fmax=1/0.2/2;
fx1=linspace(-fmax, fmax, 1501);
SY1=abs(fftshift(fft(sy1)));
 
 
sx2=0:0.4:600;  % unit in mm sampling period 0.4 mm
sy2=sin(2*pi.*sx2/5); % period of 5mm
fmax=1/0.4/2;
fx2=linspace(-fmax, fmax, 1501);
SY2=abs(fftshift(fft(sy2)));
 
 
sx3=0:3:4500;  % unit in mm sampling period 3 mm
sy3=sin(2*pi.*sx3/5); % period of 5mm
fmax=1/3/2;
fx3=linspace(-fmax, fmax, 1501);
SY3=abs(fftshift(fft(sy3)));
 
 
figure(1);
subplot(2,2,1)
plot(fx,SY)
axis([-inf, inf, 0, 800])
axis square
title('Sampling period 0.1 mm')
xlabel('1/mm')
ylabel('Spectrum')
 
subplot(2,2,2)
plot(fx1,SY1)
axis([-inf, inf,  0, 800])
axis square
title('Sampling period 0.2 mm')
xlabel('1/mm')
ylabel('Spectrum')
 
subplot(2,2,3)
plot(fx2,SY2)
axis([-inf, inf,  0, 800])
axis square
title('Sampling period 0.4 mm')
xlabel('1/mm')
ylabel('Spectrum')
 
subplot(2,2,4)
plot(fx3,SY3)
axis([-inf, inf,  0, 800])
axis square
title('Sampling period 3 mm')
xlabel('1/mm')
ylabel('Spectrum')
