% Test the validation of QPSH
% Figure 5.2 in Digital Holography by T.-C. Poon & J.-P. Liu
 
clear all; close all;
ii=logspace(-1,1,1024);
theta=linspace(0,2,1024);
[I,T]=meshgrid(ii,theta);

I1=1+I+2*(I.^0.5).*cos(T*pi);
I2=1+I+2*(I.^0.5).*sin(T*pi);
D=8*I.*I2-(I1-I2-2*I).^2;
 
Io=(I1+I2-D.^0.5)./2;
err=abs(Io-1);

figure; mesh(I,T,err);
view(2)
set(gca, 'XScale', 'log') ;
xlabel('Relative Intensity of the reference light');
ylabel('Phase difference ( \pi radian)');
colorbar
axis tight
