% 2D phase unwrapping 
% Example 6.2 in Digital Holography by T.-C. Poon & J.-P. Liu

clear all; close all;
[x,y] = meshgrid(0:0.5:256,0:0.5:256);
PHASE=15*sin(((x-200).^2+(y-225).^2)/10000)...
+0.002*((x-37).^2+(y-100).^2);
% original phase function
 
FUN=exp(1i*PHASE);
WRAP_PHASE=angle(FUN);% wrapped phase function
UNWRAP_PHASE=unwrap(WRAP_PHASE,[],1);% unwrapping along columns
UNWRAP_PHASE=unwrap(UNWRAP_PHASE,[],2);% unwrapping along rows
 
figure; mesh(x,y,PHASE);view([-30,52])
title('Original phase (radian)')
colorbar
set (gca, 'xtick', [0 125 250]);
set (gca, 'ytick', [0 125 250]);

figure; mesh(x,y,WRAP_PHASE);view([-30,52])
title('Wrapped phase (radian)')
colorbar
set (gca, 'xtick', [0 125 250]);
set (gca, 'ytick', [0 125 250]);

figure; mesh(x,y,UNWRAP_PHASE);view([-30,52])
title('Unwrapped phase (radian)')
colorbar
set (gca, 'xtick', [0 125 250]);
set (gca, 'ytick', [0 125 250]);
