% Generation of a detour-phase CGH
% Example 7.1 in Digital Holography by T.-C. Poon & J.-P. Liu

clear all; close all;
I=imread('DH64.bmp', 'bmp'); 
% please prepare a 8 bit, 64x64 pixels input image
% otherwise the code must adjusted accordingly
 
I=double(I);
figure; imshow(abs(I));
title('Original object')
 
PH=rand([64,64]);
I=I.*exp(2i*pi*PH);% add a random phase to the object
 
FTS=fftshift(ifft2(fftshift(I)));
A=abs(FTS);
figure;imshow(mat2gray(A));
title('Object spectrum')
 
A=A./max(max(A))*15;
A=round(A);% The amplitude is divided into 16 levels
B=angle(conj(FTS));
B=B-min(min(B));
B=B./max(max(B))*7;
B=round(B);% The phase is divided into 8 levels
H=zeros(1024);
 
 for m=1:64;
     for n=1:64;
         P=zeros(16);
         a=A(m,n);
         b=B(m,n);
         c=fix(a/2);
         d=rem(a,2);
         P(9-c:8+c+d,(1+b):(9+b))=1;
         H(16*(m-1)+1:16*(m-1)+16,16*(n-1)+1:16*(n-1)+16)=P;
     end
 end
 
figure; imshow(H)
title('Detour-phase CGH')
 
%Reconstruction (FFT)
R=fftshift(ifft2(fftshift(H)));
figure; imshow(100.*mat2gray(abs(R)));
title('Reconstructed image')
