% Generation of a kinoform CGH
% Fig. 7.4 in Digital Holography by T.-C. Poon & J.-P. Liu

clear all; close all;
I=imread('cameraman.tif', 'tif'); 
I=double(I);
figure; imshow(mat2gray(I));
title('Original object')
 
PH=rand([256,256]);
I=I.*exp(2i*pi*PH);% add a random phase to the object
 
FTS=fftshift(ifft2(fftshift(I)));
A=abs(FTS);
figure; imshow(mat2gray(A));
title('Spectrum modulus')
B=angle(FTS);
figure; imshow(mat2gray(B));
title('Spectrum phase')

%Reconstruction (FFT)
R=fftshift(ifft2(fftshift(exp(-1j*B))));
figure; imshow(mat2gray(abs(R)));
title('Reconstructed image')
