% Example of IFTA
% Example 7.2 in Digital Holography by T.-C. Poon & J.-P. Liu 

clear all; close all;
I=imread('cameraman.tif', 'tif');
I=double(I);
I=I./max(max(I));
avg1=mean(mean(I));
figure;imshow(mat2gray(I));
title('Original object');
figure;
axis([0,101,0,1]);
xlabel('Number of iterations')
ylabel('RMSE')
hold on
I1=I;
for n=1:100; % iterations to optimize the phase hologram
 
H=fftshift(fft2(fftshift(I1)));
I2=fftshift(ifft2(fftshift(exp(1j.*angle(H)))));
avg2=mean(mean(abs(I2)));
I2=(I2./avg2).*avg1;
rmse=(mean(mean((abs(I2)-I).^2)))^0.5;
plot(n,rmse, 'o'); 
pause(0.3); % To see the error in each iteration.
I1=I.*exp(1j*angle(I2));
end
hold off
I2=I2./max(max(abs(I2)));
figure;imshow(abs(I2));
title('Reconstructed image')
